
; podpogram na porovnani dvou 32bit cisel, adresy v @R0, @R1
; @R0 => @R1  CY=1
; @R0 <  @R1  CY=0
; @R0 =  @R1  CY=1 & ACC=0
cmp:	INC	R0		;
	INC	R0		;
	INC	R0		;
	INC	R1		;
	INC	R1		;
	INC	R1		; zacneme od vyssich cislic
	MOV	A, @R1		;
	CPL	A		; dvojkovy doplnek
	ADD	A, @R0		; porovnani cislic 3 radu
	CPL	A		;
	JZ	mm1		; ACC=0, rovnost
	RET			; 
mm1:	DEC	R0		;
	DEC	R1		;
	MOV	A, @R1		;
	CPL	A		; dvojkovy doplnek
	ADD	A, @R0		; porovnani cislic 2 radu
	CPL	A		;
	JZ	mm2		; ACC=0, rovnost
	RET			; 
mm2:	DEC	R0		;
	DEC	R1		;
	MOV	A, @R1		;
	CPL	A		; dvojkovy doplnek
	ADD	A, @R0		; porovnani cislic 1 radu
	CPL	A		;
	JZ	mm3		; ACC=0, rovnost
	RET			; 
mm3:	DEC	R0		;
	DEC	R1		;
	MOV	A, @R1		;
	CPL	A		; dvojkovy doplnek
	ADD	A, @R0		; porovnani cislic 0 radu
	CPL	A		;
	JZ	nastavC		;
	RET			;
nastavC:CLR	C		;
	CPL	C		;
	RET			; 


; podpogram na posun doleva od CY, pres CY 32bit cisla
; adresa v @R0
rotuj:	MOV	A, @R0		;
	RLC	A		;
	MOV	@R0, A		;
	INC	R0		; 0 rad	
	MOV	A, @R0		;
	RLC	A		;
	MOV	@R0, A		;
	INC	R0		; 1 rad	
	MOV	A, @R0		;
	RLC	A		;
	MOV	@R0, A		;
	INC	R0		; 2 rad	
	MOV	A, @R0		;
	RLC	A		;
	MOV	@R0, A		; 3 rad	
	RET			;


; makro na SOUCET dvou 32bit cisel [adresa1]:=[adresa1]+[adresa2]
PLUS	MACRO	adresa1, adresa2;
	NOP
	CLR	C		;
	MOV	A, adresa1	;
	ADDC	A, adresa2	;
	MOV	adresa1, A	; 1 byte
	MOV	A, adresa1+1	;
	ADDC	A, adresa2+1	;
	MOV	adresa1+1, A	; 2 byte
	MOV	A, adresa1+2	;
	ADDC	A, adresa2+2	;
	MOV	adresa1+2, A	; 3 byte
	MOV	A, adresa1+3	;
	ADDC	A, adresa2+3	;
	MOV	adresa1+3, A	; 4 byte
	NOP	
	ENDM			;

; makro na ROZDIL dvou 32bit cisel [adresa1]:=[adresa1]-[adresa2]
MINUS	MACRO	adresa1, adresa2;
	NOP			;
	CLR	C		;
	MOV	A, adresa1	;
	SUBB	A, adresa2	;
	MOV	adresa1, A	; 1 byte
	MOV	A, adresa1+1	;
	SUBB	A, adresa2+1	;
	MOV	adresa1+1, A	; 2 byte
	MOV	A, adresa1+2	;
	SUBB	A, adresa2+2	;
	MOV	adresa1+2, A	; 3 byte
	MOV	A, adresa1+3	;
	SUBB	A, adresa2+3	;
	MOV	adresa1+3, A	; 4 byte
	NOP			;
	ENDM			;

; makro na SOUCIN 16bit*16bit cisel [adresa3]:=[adresa1]*[adresa2]
; pomocna [adresa4]
SOUCIN	MACRO	adresa1, adresa2, adresa3, adresa4;
	NOP			;
; 1-1			
	MOV	A, adresa1	;
	MOV	B, adresa2	;
	MUL	AB		;
	MOV	adresa3, A	;
	MOV	adresa3+1, B	;
	MOV	adresa3+2, #0	;
	MOV	adresa3+3, #0	;
; 2-1
	MOV	A, adresa1+1	;
	MOV	B, adresa2	;
	MUL	AB		;
	MOV	adresa4, #0	;
	MOV	adresa4+1, A	;
	MOV	adresa4+2, B	;
	MOV	adresa4+3, #0	;
	PLUS	adresa3, adresa4;
; 1-2
	MOV	A, adresa1	;
	MOV	B, adresa2+1	;
	MUL	AB		;
	MOV	adresa4, #0	;
	MOV	adresa4+1, A	;
	MOV	adresa4+2, B	;
	MOV	adresa4+3, #0	;
	PLUS	adresa3, adresa4;
; 2-2
	MOV	A, adresa1+1	;
	MOV	B, adresa2+1	;
	MUL	AB		;
	MOV	adresa4, #0	;
	MOV	adresa4+1, #0	;
	MOV	adresa4+2, A	;
	MOV	adresa4+3, B	;
	PLUS	adresa3, adresa4;
	NOP			;
	ENDM			;

; makro na PODIL 32bit a 32bit cisla [adresa3]:=[adresa1] div [adresa2]
; pomocna [adresa4] , pocitadlo v R2
PODIL	MACRO	adresa1, adresa2, adresa3, adresa4;
	NOP			;
	MOV	R2, #32		; prednastaveni 32 krat	
deldal:	MOV	R0, #adresa1	; 
	CALL	rotuj		; ziskani nejvyssiho bitu delence do CY
	MOV	R0, #adresa4	;
	CALL	rotuj		; bit co je vyse v CY do pomocneho delence
	MOV	R0, #adresa4	; adresa pomocneho delence
	MOV	R1, #adresa2	; adresa delitele
	NOP	
	CALL	cmp		; porovnani
	NOP
	JNC	neodcit		; pokud delenec<delitel skok
	MOV	R0, #adresa3	; pokud delenec>=delitel, 
	CALL	rotuj		; subpodil CY=1  do vysledku
	MINUS	adresa4, adresa2; jinak odecist, delenec=delenec-delitel
	JMP	neodci1
neodcit:MOV	R0, #adresa3	; 
	CALL	rotuj		; subpodil  CY=0 do vysledku	
neodci1:DJNZ	R2, deldal	;
	ENDM			;

; makro na prevod bin->BCD adresa1-binvstup adresa2-BCDvystup
;
BINBCD	MACRO	adresa1, adresa2;
	MOV	R2, #32		; pocitadlo
; adresa2=adresa2+adresa2 , nasobeni dvakrat
znobi:	MOV	A, adresa2	;	
	ADD	A, adresa2	;
	DA	A		; spodni 2 cislice
	MOV	adresa2, A	;
	MOV	A, adresa2+1	;
	ADDC	A, adresa2+1	;
	DA	A		; dalsi 2 cislice
	MOV	adresa2+1, A	;
	MOV	A, adresa2+2	;
	ADDC	A, adresa2+2	;
	DA	A		; dalsi 2 cislice
	MOV	adresa2+2, A	;
	MOV	A, adresa2+3	;
	ADDC	A, adresa2+3	;
	DA	A		; dalsi 2 cislice
	MOV	adresa2+3, A	;
; ziskani horniho bitu z adresa1
	MOV	R0, #adresa1	;
	CALL	rotuj		;
	JNC	dabin		; je-li CY=1 prictem 1
	MOV	A, adresa2	;
	ADD	A, #1		;
	DA	A		; spodni 2 cislice
	MOV	adresa2, A	;
	MOV	A, adresa2+1	;
	ADDC	A, #0		;
	DA	A		; dalsi 2 cislice
	MOV	adresa2+1, A	;
	MOV	A, adresa2+2	;
	ADDC	A, #0		;
	DA	A		; dalsi 2 cislice
	MOV	adresa2+2, A	;
	MOV	A, adresa2+3	;
	ADDC	A, #0		;
	DA	A		; dalsi 2 cislice
	MOV	adresa2+3, A	;
dabin:	DJNZ	R2, znobi	;
	ENDM			;